﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Microsoft.Samples.DslTools.ConfigurationSectionDesigner
{
    public abstract partial class BaseConfigurationType
    {
        #region Convenience Properties

        /// <summary>
        /// Gets the value of the calculated TypeName property.
        /// </summary>
        /// <remarks>
        /// This property is used to show the actual type of the MEL in the shape,
        /// i.e. ConfigurationElement, ConfigurationElementCollection or ConfigurationSection.
        /// </remarks>
        public string GetTypeNameValue()
        {
            return this.GetType().Name;
        }

        /// <summary>
		/// Gets the full type name of this configuration type.
        /// </summary>
        public override string FullName
        {
            get
            {
                return string.Format( "{0}.{1}", this.ActualNamespace, this.Name );
            }
        }
        /// <summary>
        /// Gets the actual namespace this configuration type should be declared in.
        /// </summary>
        public string ActualNamespace
        {
            get
            {
                return string.IsNullOrEmpty( this.Namespace ) ? this.ConfigurationSectionModel.Namespace : this.Namespace;
            }
        }

        #endregion
    }
}
